"""modified field types to ENUM

Revision ID: 43fa790ae4a2
Revises: d23c2d48a82e
Create Date: 2018-09-11 10:16:03.082118

"""
from alembic import op
import sqlalchemy as sa
from sqlalchemy.dialects import postgresql


# revision identifiers, used by Alembic.
revision = '43fa790ae4a2'
down_revision = 'd23c2d48a82e'
branch_labels = None
depends_on = None


vehicle_type_enum = postgresql.ENUM('CAR', 'AUTO_RICKSHAW', name='vehicletype')
ride_status_enum = postgresql.ENUM('USER_REQUESTED', 'USER_CANCELLED', 'DRIVER_ACCEPTED', 'DRIVER_CANCELLED', 'TIMEDOUT', 'ON_GOING', 'COMPLETED', name='ridestatus')
fuel_type_enum = postgresql.ENUM('PETROL', 'DIESEL', 'LPG', name='fueltype')


def upgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    vehicle_type_enum.create(op.get_bind())
    op.alter_column('fleet', 'fleet_for',
               existing_type=sa.VARCHAR(),
               type_=sa.Enum('CAR', 'AUTO_RICKSHAW', name='vehicletype'),
               postgresql_using="fleet_for::vehicletype",
               existing_nullable=False)

    ride_status_enum.create(op.get_bind())
    op.alter_column('ride', 'status',
               existing_type=sa.VARCHAR(),
               type_=sa.Enum('USER_REQUESTED', 'USER_CANCELLED', 'DRIVER_ACCEPTED', 'DRIVER_CANCELLED', 'TIMEDOUT', 'ON_GOING', 'COMPLETED', name='ridestatus'),
               postgresql_using="status::ridestatus",
               existing_nullable=False)

    fuel_type_enum.create(op.get_bind())
    op.alter_column('vehicle', 'fuel_type',
               existing_type=sa.VARCHAR(),
               type_=sa.Enum('PETROL', 'DIESEL', 'LPG', name='fueltype'),
               postgresql_using="fuel_type::fueltype",
               existing_nullable=False)

    op.alter_column('vehicle', 'v_type',
               existing_type=sa.VARCHAR(),
               type_=sa.Enum('CAR', 'AUTO_RICKSHAW', name='vehicletype'),
               postgresql_using="v_type::vehicletype",
               existing_nullable=False)
    # ### end Alembic commands ###


def downgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.alter_column('vehicle', 'v_type',
               existing_type=sa.Enum('CAR', 'AUTO_RICKSHAW', name='vehicletype'),
               type_=sa.VARCHAR(),
               existing_nullable=False)
    op.alter_column('vehicle', 'fuel_type',
               existing_type=sa.Enum('PETROL', 'DIESEL', 'LPG', name='fueltype'),
               type_=sa.VARCHAR(),
               existing_nullable=False)
    op.alter_column('ride', 'status',
               existing_type=sa.Enum('USER_REQUESTED', 'USER_CANCELLED', 'DRIVER_ACCEPTED', 'DRIVER_CANCELLED', 'TIMEDOUT', 'ON_GOING', 'COMPLETED', name='ridestatus'),
               type_=sa.VARCHAR(),
               existing_nullable=False)
    op.alter_column('fleet', 'fleet_for',
               existing_type=sa.Enum('CAR', 'AUTO_RICKSHAW', name='vehicletype'),
               type_=sa.VARCHAR(),
               existing_nullable=False)

    vehicle_type_enum.drop(op.get_bind())
    fuel_type_enum.drop(op.get_bind())
    ride_status_enum.drop(op.get_bind())
    # ### end Alembic commands ###
